include "Vram.inc"
include "VVram.inc"

VramTop equ Vram+VramRowSize

ext VVramFront_, RowFlags_

dseg
Backup:
    defs VVramWidth*VVramHeight
PortF0Save:
    defb 0

cseg
ToRam:
    push af
        in a,(0f0h)
        ld (PortF0Save),a
        ld a,0ddh
        out (0f0h),a
    pop af
ret

ToRom:
    push af
        ld a,(PortF0Save)
        out (0f0h),a
    pop af
ret


PatternAddress:
    push de
        ld l,a
        ld h,0
        add hl,hl ;*2
        add hl,hl ;*4
        add hl,hl ;*8
        add hl,hl ;*16
        ld de,PatternRam
        add hl,de
    pop de
ret


; void MakePatternMono(byte c, ptr<byte> pSource, byte count, byte color);
dseg
    MakePatternMono_@Param3: public MakePatternMono_@Param3
    defb 0
cseg
MakePatternMono_: public MakePatternMono_
    push af | push hl | push de | push bc
        di
            call ToRam
            exx
                call PatternAddress
                push hl
                pop ix
            exx
            ld a,(MakePatternMono_@Param3) ; color
            exx
                ld h,a
                and 03h
                ld l,a
                ld a,h
                rrca
                rrca
                and 03h
                ld h,a
            exx
            do
                ld l,4
                do
                    ld a,(de)
                    inc de
                    exx
                        ld c,a
                    exx
                    ld h,2
                    do
                        ld (ix),0
                        ld (ix+1),0
                        ld b,4
                        do
                            sla (ix) | sla (ix)
                            sla (ix+1) | sla (ix+1)
                            exx
                                sla c
                                if c
                                    ld a,(ix)
                                    or l
                                    ld (ix),a
                                    ld a,(ix+1)
                                    or h
                                    ld (ix+1),a
                                endif
                            exx
                        dwnz
                        inc ix | inc ix
                        dec h
                    while nz | wend
                    dec l
                while nz | wend
                dec c
            while nz | wend
            call ToRom
        ei
    pop bc | pop de | pop hl | pop af
ret


; void MakePatternColor(byte c, ptr<byte> pSource, byte count);
MakePatternColor_: public MakePatternColor_
    push af | push hl | push de | push bc
        di
            call ToRam
            exx
                call PatternAddress
            exx
            do
                ld b,16
                do
                    ld a,(de)
                    inc de
                    exx
                        ld (hl),a
                        inc hl
                    exx
                dwnz
                dec c
            while nz | wend
            call ToRom
        ei
    pop bc | pop de | pop hl | pop af
ret


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    push af | push hl | push bc
        ld hl,Vram
        ld bc,4000h
        di
            call ToRam
            do
                ld (hl),0
                inc hl
                dec bc
                ld a,c
                or b
            while nz | wend
            call ToRom
        ei

        ld hl,Backup
        ld bc,VVramWidth*VVramHeight
        do
            ld (hl),0
            inc hl
            dec bc
            ld a,c
            or b
        while nz | wend
    pop bc | pop hl | pop af
ret


; word Put(word vram, byte c);
Put_: public Put_
    push af | push hl | push de | push bc
        ld a,e
        ex de,hl
            call PatternAddress
        ex de,hl
        di
            call ToRam
            ld b,8
            do
                ld a,(de)
                inc de
                ld (hl),a
                ld a,(de)
                inc de
                set 5,h
                ld (hl),a
                res 5,h
                push bc
                    ld bc,40
                    add hl,bc
                pop bc
            dwnz
            call ToRom
        ei
    pop bc | pop de | pop hl | pop af
    inc hl
ret


cseg
VVramToVramRow:
    ld b,VVramWidth
    do 
        push bc 
            ld a,(de)
            inc de
            cp (hl)
            if nz
                ld (hl),a
                exx
                    push de
                        ld e,a
                        call Put_
                    pop de
                exx
            else
                exx
                    inc hl
                exx
            endif
            inc hl
        pop bc
    dwnz
    exx
        push bc
            ld bc,VramRowSize-VVramWidth
            add hl,bc
        pop bc
    exx
ret


; void VVramToVramAll();
VVramToVramAll_: public VVramToVramAll_
    push af | push hl | push de | push bc
        ld de,VVramFront_
        ld hl,Backup
        exx
            ld hl,VramTop
        exx
        ld c, VVramHeight
        do
            call VVramToVramRow
            dec c
        while nz | wend
        xor a
        ld (RowFlags_),a
        ld (RowFlags_+1),a
        ld (RowFlags_+2),a
    pop bc | pop de | pop hl | pop af
ret


; void VVramToVramChanged();
VVramToVramChanged_: public VVramToVramChanged_
    push af | push hl | push de | push bc
        ld de,VVramFront_
        ld hl,Backup
        exx
            ld hl,VramTop
            ld de,RowFlags_
            ex de,hl
                ld c,1
                ld b,(hl)
                inc hl
            ex de,hl
        exx
        ld c, VVramHeight ; vertical count    
        do
            exx
                ld a,b
                and c
            exx
            if nz
                call VVramToVramRow            
            else
                push bc
                    ld bc,VVramWidth
                    add hl,bc
                    ex de,hl
                        add hl,bc
                    ex de,hl
                pop bc
                exx
                    push bc
                        ld bc,VramRowSize
                        add hl,bc
                    pop bc
                exx
            endif
            exx
                sla c
                if z
                    ex de,hl
                        ld c,1
                        ld b,(hl)
                        inc hl
                    ex de,hl
                endif
            exx
            dec c
        while nz | wend

        xor a
        ld (RowFlags_),a
        ld (RowFlags_+1),a
        ld (RowFlags_+2),a
    pop bc | pop de | pop hl | pop af
ret